local ControlScene=class("directionControl", function ()
	return display.newLayer()
end)

local scheduler = require("framework.scheduler")


function ControlScene:ctor(...)

	--动作
	self.isRight = false  --左右移动
	self.isLeft = false

	self.Rbullet=true  	--左右射击
	self.Lbullet=false

	self.down = true  -- 下落
 
	self.isJump = true  --跳

	self.up=false--跳一次哦

	self.guai=false --子弹打住怪后不检测碰撞

	self:init(...)

	scenenum = ModifyData.getSceneNumber()
	chapternum = ModifyData.getChapterNumber()
	
end

function ControlScene:init(params)

	--得到地板
	 local floor=params.floor
	 self.floor=floor:getObjects()
	
	--得到英雄
	 self.poluoSp=params.name
	--得到怪
	self.monster=params.Rmonster
	
	--得到层
	self.layer=params.layer

	self.bulletTab={}	--存子弹

	--向右走
	
	self.rightBtn=ccui.Button:create("btn3.png","btn-3.png")
	self.rightBtn:setPosition(cc.p(250,50))
	self.rightBtn:addTouchEventListener(function (ref,type )
		if type == ccui.TouchEventType.began then
			self.isRight=true
			self.Rbullet=true
			self.Lbullet=false
			self.down=true
			local animation=cc.Animation:create()
			animation:setDelayPerUnit(0.1)--帧间隔
			animation:addSpriteFrameWithFile("timo_walk_right_1.png")
			animation:addSpriteFrameWithFile("timo_walk_right_2.png")
			local animate=cc.Animate:create(animation)
			self.foreverRight=cc.RepeatForever:create(animate)
			self.poluoSp:runAction(self.foreverRight)

			self._schedulerRight=scheduler.scheduleUpdateGlobal(handler(self, self.myUpdate))
	
		end
		if type == ccui.TouchEventType.ended then
			
			self.isRight=false

			self.down=true
			self.poluoSp:stopAction(self.foreverRight)
			local animation=cc.Animation:create()
			animation:setDelayPerUnit(0.1)--帧间隔 
			animation:addSpriteFrameWithFile("timo_walk_right_1.png")--停止时图片
			local animate=cc.Animate:create(animation)
			self.poluoSp:runAction(animate)
			scheduler.unscheduleGlobal(self._schedulerRight)
			
		end
		if type ==ccui.TouchEventType.canceled then
			self.isRight=false
			self.poluoSp:stopAction(self.foreverRight)
			local animation=cc.Animation:create()
			animation:setDelayPerUnit(0.1)--帧间隔
			animation:addSpriteFrameWithFile("timo_walk_right_1.png")
			local animate=cc.Animate:create(animation)
			self.poluoSp:runAction(animate)
			scheduler.unscheduleGlobal(self._schedulerRight)
			
		end
	end)
	self:addChild(self.rightBtn,2)
	

	--左按钮
	self.leftBtn=ccui.Button:create("btn1.png","btn-1.png")
	self.leftBtn:setPosition(cc.p(100,50))
	self.leftBtn:addTouchEventListener(function ( ref,type )

		if type ==ccui.TouchEventType.began then
			self.isLeft=true
			self.Lbullet=true
			self.Rbullet=false
			
			self.down=true
			local animation=cc.Animation:create()
			animation:setDelayPerUnit(0.1)
			animation:addSpriteFrameWithFile("timo_walk_left_1.png")
			animation:addSpriteFrameWithFile("timo_walk_left_2.png")
			local animate=cc.Animate:create(animation)
			self.foreverLeft=cc.RepeatForever:create(animate)
			self.poluoSp:runAction(self.foreverLeft)
			self._schedulerLeft=scheduler.scheduleUpdateGlobal(handler(self, self.myUpdate))
		end
		if type ==ccui.TouchEventType.ended then
			self.isLeft=false
			--print("lll")
			self.down=true
			self.poluoSp:stopAction(self.foreverLeft)
			local animation = cc.Animation:create()
    			animation:setDelayPerUnit(0.1)   -- 帧间隔
     			animation:addSpriteFrameWithFile("timo_walk_left_1.png")
			local animate=cc.Animate:create(animation)
			self.poluoSp:runAction(animate)
			scheduler.unscheduleGlobal(self._schedulerLeft)
			
		end
		if type ==ccui.TouchEventType.canceled then
			self.isLeft=false
			self.poluoSp:stopAction(self.foreverLeft)
       			local animation = cc.Animation:create()
    			animation:setDelayPerUnit(0.1)   -- 帧间隔
     			animation:addSpriteFrameWithFile("timo_walk_left_1.png")
     			local animate = cc.Animate:create(animation)
     			self.poluoSp:runAction(animate)
       			scheduler.unscheduleGlobal(self._schedulerLeft)
       			  
		end
	end)
	self:addChild(self.leftBtn,2)

	--跳
	self.jumpBtn=ccui.Button:create("btn2.png","btn-2.png")
	self.jumpBtn:setPosition(175,125)
	self.jumpBtn:addTouchEventListener(function ( ref,type )
		if type == ccui.TouchEventType.began then
			
				
			if self.up==true then
				self.up=false
				
				self:heroJump()
			end
			
			
		end
		if type ==ccui.TouchEventType.ended then
			
		end
		if type == ccui.TouchEventType.canceled then
			
		end
	end)
	self:addChild(self.jumpBtn)

	--攻击
	self.bulletBtn=ccui.Button:create("attack.png","attack1.png")
	self.bulletBtn:setPosition(display.cx*1.8,75)
	self.bulletBtn:addTouchEventListener(function ( ref,type )
	
		if type ==ccui.TouchEventType.began then
				self:bullet()
				
		end
		if type ==ccui.TouchEventType.ended then

		end
		if type == ccui.TouchEventType.canceled then
			
		end
	end)
	self:addChild(self.bulletBtn,2)

	self.schedule=scheduler.scheduleUpdateGlobal(handler(self, self.beginCollision),0.08)
end
--子弹
function ControlScene:bullet(  )
	local o=cc.Sprite:create("zidan.png")
	local heroX=self.poluoSp:getPositionX()
	local heroY=self.poluoSp:getPositionY()
	o:setPosition(cc.p(heroX+50,heroY+30))
	self.layer:addChild(o)
	
	self.bulletTab[#self.bulletTab+1]=o 
	local moveby
	if self.Rbullet==true then
		moveby=cc.MoveBy:create(1,cc.p(200,0))
		
	
	end
	if self.Lbullet==true then
		moveby=cc.MoveBy:create(1,cc.p(-200,0))
	
	end

	local call = cc.CallFunc:create(function ()	
      		o:removeFromParent()
      		table.remove(self.bulletTab,1)
		end)
	
	local seq=cc.Sequence:create(moveby,call)
	o:runAction(seq)
end

--移动
function ControlScene:myUpdate( dt )   
	
	if self.isRight then
		if self.poluoSp:getPositionX()<display.right-150 then
			
		self.poluoSp:setPosition(cc.p(self.poluoSp:getPositionX()+3,self.poluoSp:getPositionY()))
		end
	end
	if self.isLeft then
		if self.poluoSp:getPositionX()>0 then
		self.poluoSp:setPosition(cc.p(self.poluoSp:getPositionX()-3,self.poluoSp:getPositionY()))
		end
	end	 
	
end

function ControlScene:beginCollision()
 	if self.poluoSp  then 
 		self:collisionListener()
    end 
end

--跳跃函数
function ControlScene:heroJump( )
	self.down=false
	if self.isJump  then
		local moveby=cc.MoveBy:create(0.6,cc.p(0,150))
		local call = cc.CallFunc:create(function ()	
			self.isJump = true
      		self.jumpBtn:setEnabled(false)
      		self.down=true
      		
		end)
		self.sequen = cc.Sequence:create(moveby,call)	
		self.poluoSp:runAction(self.sequen)
	end
end

--子弹怪物碰撞检测
function ControlScene:bulletListener()
	
	self:collisionListener2()--添加怪物与英雄碰撞监听

	for k,v in pairs(self.monster) do
		local monsterRect=self:newRect3(v.sp)
		
		if v.hp<900 then
				v.hp=v.hp+1 --三秒恢复一个状态 
				if v.hp <= 0 then
					v.hp=1
				end
		end
		if v.hp==900 then
			
			cc.Director:getInstance():getActionManager():resumeTarget(v.sp)--怪物恢复动作

		end
		if v.hp<=50 then
			cc.Director:getInstance():getActionManager():resumeTarget(v.sp)--怪物恢复动作

				v:KillMoster()--动画
				ModifyData.USERDATA.CoinsNumber=ModifyData.USERDATA.CoinsNumber+v.money	
			
			local node=self:getParent()
			node.lab1:setString(ModifyData.USERDATA.CoinsNumber)
		--产生随机数
		-- local r = math.random(1,10)
		-- --添加道具
		-- if r<=4 and r>0 then
		-- 	local daoju=cc.Sprite:create("daoju"..r..".png")
		-- daoju:setPosition(cc.p(v.sp:getPosition()))
		-- self:addChild(daoju)
		-- print("fsdghdhftjhfj")
		-- if r==1 then
		-- 	print("fsdgdhfhjjkghkhkkkgk2514561455")
		-- 	local animation=cc.Animation:create()
		-- 	animation:setDelayPerUnit(0.2)--帧间隔
		-- 	animation:addSpriteFrameWithFile("coin0.png")
		-- 	animation:addSpriteFrameWithFile("coin1.png")
		-- 	animation:addSpriteFrameWithFile("coin2.png")
		-- 	animation:addSpriteFrameWithFile("coin3.png")
		-- 	local animate=cc.Animate:create(animation)
		-- 	local circle=cc.RepeatForever:create(animate)
		-- 	daoju:runAction(circle)
		-- end
		-- end
			table.remove(self.monster,k)
			--胜利界面
			if #self.monster==0 then
				local winlayer=WinLayer.new()
				winlayer:setPosition(cc.p(0,200))
				transition.moveTo(winlayer,{time = 0.7, y = 0})
 				self:addChild(winlayer,2)
 				--修改数据
 				self:modify()
			end
		end
		v:removeZiDan()
		for m,n in pairs(self.bulletTab) do
			local bulletRect=self:newRect3(n)
			
			if cc.rectIntersectsRect(monsterRect,bulletRect) then
				v.hp=v.hp-300
				
				print(self.guai)
				cc.Director:getInstance():getActionManager():pauseTarget(v.sp)--怪物暂停
				n:removeFromParent()
				table.remove(self.bulletTab,m)
				
			end

			if math.floor(v.hp/300)==2   then
				v:Changezhuangtai(1)

			elseif math.floor(v.hp/300)==1 then
				v:Changezhuangtai(2)
			elseif math.floor(v.hp/300)==0 then
				v:Changezhuangtai(3)

				
			end

		end
	end
end
--修改数据
function ControlScene:modify()
	local tb = PublicData.SCENETABLE
		if chapternum<#Data.SCENE[scenenum] then
			tb[scenenum][chapternum+1].lock = 0
		end	
	local str = json.encode(tb)
    ModifyData.writeToDoc( "scenedata.txt",str )

end

--怪物与人
function ControlScene:collisionListener2( ... )

	-- if self.guai==true then
		
		for k,v in pairs(self.monster) do
		local monsterRect=self:newRect3(v.sp)
		local heroRect=self:newRect2(self.poluoSp)
		if cc.rectIntersectsRect(monsterRect,heroRect) then
			--失败页面
			scheduler.unscheduleGlobal(self.schedule)
			local loseLayer=LoseLayer.new()
			loseLayer:setPosition(cc.p(0,200))
			transition.moveTo(loseLayer,{time = 0.7, y = 0})
 			self:addChild(loseLayer,2)
 			local call=cc.CallFunc:create(function (  )
 					cc.Director:getInstance():pause()
 				end
 				)
 			local del=cc.DelayTime:create(0.8)
 			local seq=cc.Sequence:create(del,call)
 			loseLayer:runAction(seq)
 			

		end
	-- end

	end
	
end


--人物与地板碰撞检测
function ControlScene:collisionListener(  )
	
	local posY=3
	
	local isDown
	if self.floor then
		--得到地板
		isDown = #self.floor

		for k,v in ipairs(self.floor) do
			local floorRect=self:newRect(v)
			local heroRect=self:newRect1(self.poluoSp)

			if cc.rectIntersectsRect( floorRect, heroRect) then
				self.up=true
				if self.down then
					self.poluoSp:stopAction(self.sequen)
					self.isMove=false
					-- self.down=false
					self.jumpBtn:setEnabled(true)
				
				end
			else
				isDown = isDown - 1

			end
		end
	end
	if isDown == 0 and self.down == true and self.floor then
		self.poluoSp:setPositionY(self.poluoSp:getPositionY()-posY)
	end

	self:bulletListener()--添加子弹的监听

	

end

--地板检测点
function ControlScene:newRect(v)
	--print("sgfs")
	local height=v.height
	local width=v.width
	local x=v.x
	local y=v.y
	local rect=cc.rect(x,y+height*0.8,width,10)
	return rect
end

--英雄检测点
function ControlScene:newRect1(v)

	local size=v:getContentSize()
	local x=v:getPositionX()
	local y=v:getPositionY()
	local rect=cc.rect(x,y,size.width,1)--脚下的位置
	return rect
end

--检测点
function ControlScene:newRect2( v )
	
	local size=v:getContentSize()
	local x=v:getPositionX()
	local y=v:getPositionY()
	local rect=cc.rect(x,y,size.width,size.height)--脚下的位置
	return rect
end

--怪物,子弹监测点
function ControlScene:newRect3( v )

	local size=v:getContentSize()
	local x=v:getPositionX()-85
	local y=v:getPositionY()
	local rect=cc.rect(x,y,size.width,size.height)
	return rect
end








return ControlScene