
local GameScene = class("GameScene", function()
    return display.newScene("GameScene")
end)
local scheduler = require("framework.scheduler")


local coins = 1

function GameScene:ctor()
    --keyPad
	self:setKeypadEnabled(true)
	self:addNodeEventListener(cc.KEYPAD_EVENT , function(event)
		if event.key == "back" then
			cc.Director:getInstance():replaceScene(require("app.scenes.Chapter").new())
		elseif event.key == "menu" then
			audio.pauseMusic("backmusic.mp3")
			SetLayer.isPlayMusic = false
		end
	end)

	scenenum = ModifyData.getSceneNumber()
	chapternum = ModifyData.getChapterNumber()

    self:init()

end

function GameScene:init()

	self.layer = cc.Layer:create()
	self.layer:setContentSize(cc.size(960, 640))
	local scaleX = display.width/self.layer:getContentSize().width
	local scaleY = display.height/self.layer:getContentSize().height
	self.layer:setScaleX(scaleX)
	self.layer:setScaleY(scaleY)
	self.layer:setAnchorPoint(0,0)
	self.layer:setPosition(0, 0)
	self:addChild(self.layer)

	local bg=cc.Sprite:create("scenebg"..scenenum..".png")
	local scaleX1 = display.width/bg:getContentSize().width
	local scaleY1= display.height/bg:getContentSize().height
	bg:setScaleX(scaleX1)
	bg:setScaleY(scaleY1)
	bg:setPosition(display.cx,display.cy)
	self.layer:addChild(bg)

	local str = ModifyData.readFilebyName( "userdata.txt" )
    ModifyData.USERDATA = json.decode(str)

	-- 风速药剂
	local fengsuLab=cc.ui.UILabel.new({
		text=ModifyData.USERDATA.fengsu,
		size=30,
		color=cc.c3b(255, 255, 255),
		align=cc.Text_ALIGNMENT_LEfT,
		font="UVNBanhMi.ttf",
		valign=cc.VERTICAL_TEXT_ALIGNMENT_TOP
		})
	fengsuLab:setPosition(cc.p(display.right*0.25,display.height*0.95))
	self.layer:addChild(fengsuLab,2)

	local fengsu=ccui.Button:create("fengsu.png")	--添加风速鞋子
	fengsu:setPosition(cc.p(display.right*0.2,display.height*0.95))
	fengsu:addTouchEventListener(function ( ref,type )

		if type==ccui.TouchEventType.ended then
			
		end
	end)
	self.layer:addChild(fengsu,2)

	local bingdongLab=cc.ui.UILabel.new({
		text=ModifyData.USERDATA.bingdong,
		size=30,
		color=cc.c3b(255, 255, 255),
		align=cc.Text_ALIGNMENT_LEfT,
		font="UVNBanhMi.ttf",
		valign=cc.VERTICAL_TEXT_ALIGNMENT_TOP
		})
	bingdongLab:setPosition(cc.p(display.right*0.37,display.height*0.95))
	self.layer:addChild(bingdongLab,2)

	local bingdong=ccui.Button:create("bingdong.png")	--添加冰冻之心
	bingdong:setPosition(cc.p(display.right*0.32,display.height*0.95))
	bingdong:addTouchEventListener(function ( ref,type )

		if type==ccui.TouchEventType.ended then
			
		end
	end)
	self.layer:addChild(bingdong,2)

	local wuqiLab=cc.ui.UILabel.new({
		text=ModifyData.USERDATA.wuqi,
		size=30,
		color=cc.c3b(255, 255, 255),
		font="UVNBanhMi.ttf",
		align=cc.Text_ALIGNMENT_LEfT,
		valign=cc.VERTICAL_TEXT_ALIGNMENT_TOP
		})
	wuqiLab:setPosition(cc.p(display.right*0.49,display.height*0.95))
	self.layer:addChild(wuqiLab,2)

	local wuqi=ccui.Button:create("wuqi.png")	--添加冰冻之心
	wuqi:setPosition(cc.p(display.right*0.44,display.height*0.95))
	wuqi:addTouchEventListener(function ( ref,type )

		if type==ccui.TouchEventType.ended then
			
		end
	end)
	self.layer:addChild(wuqi,2)

	--暂停
	local back = cc.ui.UIPushButton.new({normal = "newPause_Normal.png",pressed = "newPause_Select.png"}, {scale9 = true})
	print("11")
    back:onButtonClicked(function(event)
		cc.Director:getInstance():pause()--暂停
		print("22")
		--暂停界面
		local layer = PauseLayer.new()
		layer:setPosition(cc.p(0,0))
		self:addChild(layer,2)
	end)
	back:setPosition(cc.p(50, display.top-50))
	self:addChild(back,20)

	--金币
	coins = ModifyData.getCoinsNumber()
	local bonusSp = cc.Sprite:create("bonus.png")
	bonusSp:pos(display.right-120, display.top-50)
	self:addChild(bonusSp)
	self.lab1 = cc.ui.UILabel.new({
    	text=ModifyData.USERDATA.CoinsNumber,
    	size=30,
    	font="UVNBanhMi.ttf",
    	color=cc.c3b(255, 255, 255)
    	})
    self.lab1:setPosition(cc.p(80,30))
	bonusSp:addChild(self.lab1)

	--加载ui
	self.titleMap=cc.TMXTiledMap:create("scene"..scenenum.."-"..chapternum..".tmx")
	self.layer:addChild(self.titleMap)

	self.floor=self.titleMap:getObjectGroup("floor")
	self.move=self.titleMap:getObjectGroup("Move")
	self.monsterObject=self.titleMap:getObjectGroup("Monster")

	
	
	local heroObject=self.titleMap:getObjectGroup("Hero")
	local hero=heroObject:getObject("hero")
	self.poluoSp=cc.Sprite:create("timo_walk_right_1.png")
	self.poluoSp:setAnchorPoint(cc.p(0,0))
	self.poluoSp:setPosition(cc.p(hero.x,hero.y))
	self.layer:addChild(self.poluoSp,1)

	self.monsterTab={}--怪物表
	self:addMonster()--加怪物

	local btnlayer=contorlLayer.new({name=self.poluoSp,floor=self.floor,Rmonster=self.monsterTab,layer=self.layer})
	btnlayer:setPosition(cc.p(0,0))
	
	self:addChild(btnlayer)
    

end

--初始化怪物
function GameScene:addMonster( )

	local monsterTB={}
	local tb = PublicData.SCENETABLE
	print("**"..scenenum)
	print("**"..chapternum)

	monsterTB=Data.SCENE[scenenum][chapternum].guaiwu
	dump(monsterTB)
		for k,v in ipairs(monsterTB) do
			print("怪物表")
			print(k,v)
			local begin=self.move:getObject("move"..k.."_2")
			local ended=self.move:getObject("move"..k.."_1")
			local opt = {begin,ended}
			-- --dump(opt)
			local monster1 = Monster.new(v,opt)--喷火龙
			table.insert(self.monsterTab,monster1)
			self:addChild(monster1.sp)
		end


end

function GameScene:modify()
	local tb=ModifyData.USERDATA
   local str = json.encode(tb)
    ModifyData.writeToDoc( "userdata.txt",str )
end

function GameScene:onEnter()
end

function GameScene:onExit()
end

return GameScene
