
local MainScene = class("MainScene", function()
    return display.newScene("MainScene")
end)

MainScene.isTime = 1

function MainScene:ctor()
    --keyPad
    self:setKeypadEnabled(true)
    self:addNodeEventListener(cc.KEYPAD_EVENT , function(event)
        if event.key == "back" then
            cc.Director:getInstance():replaceScene(require("app.scenes.StartScene").new())
        elseif event.key == "menu" then
            audio.pauseMusic("backmusic.mp3")
            SetLayer.isPlayMusic = false
        end
    end)

    self:init()

end

function MainScene:init(  )
    --背景
    local bg = cc.Sprite:create("bg1.png")
    bg:setAnchorPoint(cc.p(0,0))
    local scaleX = display.width/bg:getContentSize().width
    local scaleY = display.height/bg:getContentSize().height
    bg:setScaleX(scaleX)
    bg:setScaleY(scaleY)
    bg:pos(0, 0)
    self:addChild(bg)

    --返回按钮
    local backbtn = cc.ui.UIPushButton.new({normal = "btn-1.png"}, {scale9 = true})
    backbtn:onButtonClicked(function(event)
        local scene = require("app.scenes.StartScene").new()
        cc.Director:getInstance():replaceScene(scene)
    end)
    backbtn:setPosition(cc.p(50, display.top-50))
    self:addChild(backbtn,2)

    --商店按钮
    local backButton = cc.ui.UIPushButton.new({normal = "shop_button_nor.png",pressed = "shop_button_sel.png"},{scale9 = true})
            :onButtonClicked(function (  )
            cc.Director:getInstance():replaceScene(require("app.scenes.Shop").new())
            end)
            :pos(display.right*0.9,display.top*0.9)
            :addTo(self,10)

    --按钮
    local lab1 = cc.ui.UILabel.new({
        text="侏罗纪",
        size=30,
        color=cc.c3b(255, 0, 255)
        })
    lab1:setPosition(cc.p(display.right/7, display.cy))
    self:addChild(lab1,3)

    local btn1 = cc.ui.UIPushButton.new("scene01.png", {scale9 = true})
    btn1:onButtonClicked(function (  )
        ModifyData.setSceneNumber(1)
        cc.Director:getInstance():replaceScene(require("app.scenes.Chapter").new())
    end)
    btn1:setScaleX(scaleX)
    btn1:setScaleY(scaleY)
    btn1:pos(display.right/5, display.cy)
    self:addChild(btn1,2)
    
    local lab2 = cc.ui.UILabel.new({
        text="域外星空",
        size=30,
        color=cc.c3b(255, 0, 255)
        })
    lab2:setPosition(cc.p(display.cx-50, display.cy))
    self:addChild(lab2,3)

    local btn2 = cc.ui.UIPushButton.new("scene03.png", {scale9 = true})
    btn2:onButtonClicked(function (  )
        ModifyData.setSceneNumber(2)
        cc.Director:getInstance():replaceScene(require("app.scenes.Chapter").new())
    end)
    btn2:setScaleX(scaleX)
    btn2:setScaleY(scaleY)
    btn2:pos(display.cx, display.cy)
    self:addChild(btn2,2)

    local lab3 = cc.ui.UILabel.new({
        text="冰雪奇缘",
        size=30,
        color=cc.c3b(255, 0, 255)
        })
    lab3:setPosition(cc.p(display.right*2/3+50, display.cy))
    self:addChild(lab3,3)

    local btn3 = cc.ui.UIPushButton.new("scene02.png", {scale9 = true})
    btn3:onButtonClicked(function (  )
        ModifyData.setSceneNumber(3)
        cc.Director:getInstance():replaceScene(require("app.scenes.Chapter").new())
    end)
    btn3:setAnchorPoint(cc.p(0,0.5))
    btn3:setScaleX(scaleX)
    btn3:setScaleY(scaleY)
    btn3:pos(display.right*2/3, display.cy)
    self:addChild(btn3,2)
end

function MainScene:onEnter()
end

function MainScene:onExit()
end

return MainScene
